Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkGridTransform Class Reference

`#include <vtkGridTransform.h>`

Inheritance diagram for vtkGridTransform:

[legend]
Collaboration diagram for vtkGridTransform:

[legend]
List of all members.

## Detailed Description

a nonlinear warp transformation

Date:
  2002/05/13 21:44:42

Revision:
  1.12

vtkGridTransform describes a nonlinear warp transformation as a set of displacement vectors sampled along a uniform 3D grid.

Warning:
  The inverse grid transform is calculated using an iterative method, and is several times more expensive than the forward transform.

See also:
  vtkThinPlateSplineTransform vtkGeneralTransform vtkTransformToGrid

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (94%)

CVS logs (CVSweb):
  - .`cxx` (`/Hybrid/vtkGridTransform.cxx)`
  - .`h` (`/Hybrid/vtkGridTransform.h)`

Tests:
  vtkGridTransform (Tests)

Definition at line 55 of file vtkGridTransform.h.

## Public Types
typedef vtkWarpTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
virtual void | PrintSelf (ostream &os, vtkIndent indent)
vtkAbstractTransform * | MakeTransform ()
unsigned long | GetMTime ()
virtual void | SetDisplacementGrid (vtkImageData *)
virtual vtkImageData * | GetDisplacementGrid ()
virtual void | SetDisplacementScale (float)
virtual float | GetDisplacementScale ()
virtual void | SetDisplacementShift (float)
virtual float | GetDisplacementShift ()
void | SetInterpolationMode (int mode)
virtual int | GetInterpolationMode ()
void | SetInterpolationModeToNearestNeighbor ()
void | SetInterpolationModeToLinear ()
void | SetInterpolationModeToCubic ()
const char * | GetInterpolationModeAsString ()
## Static Public Methods
vtkGridTransform * | New ()
int | IsTypeOf (const char *type)
vtkGridTransform * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkGridTransform ()
| ~vtkGridTransform ()
void | InternalUpdate ()
void | InternalDeepCopy (vtkAbstractTransform *transform)
void | ForwardTransformDerivative (const float in[3], float out[3], float derivative[3][3])
void | ForwardTransformDerivative (const double in[3], double out[3], double derivative[3][3])
void | InverseTransformPoint (const float in[3], float out[3])
void | InverseTransformPoint (const double in[3], double out[3])
void | InverseTransformDerivative (const float in[3], float out[3], float derivative[3][3])
void | InverseTransformDerivative (const double in[3], double out[3], double derivative[3][3])
void | ForwardTransformPoint (const float in[3], float out[3])
void | ForwardTransformPoint (const double in[3], double out[3])
## Protected Attributes
void(* | InterpolationFunction )(float point[3], float displacement[3], float derivatives[3][3], void *gridPtr, int gridType, int inExt[6], int inInc[3])
int | InterpolationMode
vtkImageData * | DisplacementGrid
float | DisplacementScale
float | DisplacementShift

## Member Typedef Documentation

typedef vtkWarpTransform vtkGridTransform::Superclass

| Reimplemented from vtkWarpTransform. Definition at line 59 of file vtkGridTransform.h.

## Constructor & Destructor Documentation

vtkGridTransform::vtkGridTransform | ( |  | ) | `[protected]`

vtkGridTransform::~vtkGridTransform | ( |  | ) | `[protected]`

## Member Function Documentation

vtkGridTransform* vtkGridTransform::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkGridTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkWarpTransform.

int vtkGridTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkWarpTransform.

virtual int vtkGridTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkWarpTransform.

vtkGridTransform* vtkGridTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkWarpTransform.

virtual void vtkGridTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkWarpTransform.

virtual void vtkGridTransform::SetDisplacementGrid | ( | vtkImageData * |  | ) | `[virtual]`

| Set/Get the grid transform (the grid transform must have three components for displacement in x, y, and z respectively). The vtkGridTransform class will never modify the data.

virtual vtkImageData* vtkGridTransform::GetDisplacementGrid | ( |  | ) | `[virtual]`

| Set/Get the grid transform (the grid transform must have three components for displacement in x, y, and z respectively). The vtkGridTransform class will never modify the data.

virtual void vtkGridTransform::SetDisplacementScale | ( | float |  | ) | `[virtual]`

| Set scale factor to be applied to the displacements. This is used primarily for grids which contain integer data types. Default: 1

virtual float vtkGridTransform::GetDisplacementScale | ( |  | ) | `[virtual]`

| Set scale factor to be applied to the displacements. This is used primarily for grids which contain integer data types. Default: 1

virtual void vtkGridTransform::SetDisplacementShift | ( | float |  | ) | `[virtual]`

| Set a shift to be applied to the displacements. The shift is applied after the scale, i.e. x = scale*y + shift. Default: 0

virtual float vtkGridTransform::GetDisplacementShift | ( |  | ) | `[virtual]`

| Set a shift to be applied to the displacements. The shift is applied after the scale, i.e. x = scale*y + shift. Default: 0

void vtkGridTransform::SetInterpolationMode | ( | int | mode | ) |

| Set interpolation mode for sampling the grid. Higher-order interpolation allows you to use a sparser grid. Default: Linear.

virtual int vtkGridTransform::GetInterpolationMode | ( |  | ) | `[virtual]`

| Set interpolation mode for sampling the grid. Higher-order interpolation allows you to use a sparser grid. Default: Linear.

void vtkGridTransform::SetInterpolationModeToNearestNeighbor | ( |  | ) | `[inline]`

| Set interpolation mode for sampling the grid. Higher-order interpolation allows you to use a sparser grid. Default: Linear. Definition at line 89 of file vtkGridTransform.h. References VTK_GRID_NEAREST.

void vtkGridTransform::SetInterpolationModeToLinear | ( |  | ) | `[inline]`

| Set interpolation mode for sampling the grid. Higher-order interpolation allows you to use a sparser grid. Default: Linear. Definition at line 91 of file vtkGridTransform.h. References VTK_GRID_LINEAR.

void vtkGridTransform::SetInterpolationModeToCubic | ( |  | ) | `[inline]`

| Set interpolation mode for sampling the grid. Higher-order interpolation allows you to use a sparser grid. Default: Linear. Definition at line 93 of file vtkGridTransform.h. References VTK_GRID_CUBIC.

const char * vtkGridTransform::GetInterpolationModeAsString | ( |  | ) | `[inline]`

| Set interpolation mode for sampling the grid. Higher-order interpolation allows you to use a sparser grid. Default: Linear. Definition at line 151 of file vtkGridTransform.h. References InterpolationMode, VTK_GRID_CUBIC, VTK_GRID_LINEAR, and VTK_GRID_NEAREST.

vtkAbstractTransform* vtkGridTransform::MakeTransform | ( |  | ) | `[virtual]`

| Make another transform of the same type. Implements vtkAbstractTransform.

unsigned long vtkGridTransform::GetMTime | ( |  | ) | `[virtual]`

| Get the MTime. Reimplemented from vtkAbstractTransform.

void vtkGridTransform::InternalUpdate | ( |  | ) | `[protected, virtual]`

| Update the displacement grid. Reimplemented from vtkAbstractTransform.

void vtkGridTransform::InternalDeepCopy | ( | vtkAbstractTransform * | transform | ) | `[protected, virtual]`

| Copy this transform from another of the same type. Reimplemented from vtkAbstractTransform.

void vtkGridTransform::ForwardTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) | `[protected, virtual]`

| Internal functions for calculating the transformation. Implements vtkWarpTransform.

void vtkGridTransform::ForwardTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) | `[protected, virtual]`

| Internal functions for calculating the transformation. Implements vtkWarpTransform.

void vtkGridTransform::ForwardTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) | `[protected, virtual]`

| Calculate the forward transform as well as the derivative. Implements vtkWarpTransform.

void vtkGridTransform::ForwardTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) | `[protected, virtual]`

| Calculate the forward transform as well as the derivative. Implements vtkWarpTransform.

void vtkGridTransform::InverseTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) | `[protected, virtual]`

| If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint. The inverse transformation is calculated from using Newton's method. Reimplemented from vtkWarpTransform.

void vtkGridTransform::InverseTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) | `[protected, virtual]`

| If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint. The inverse transformation is calculated from using Newton's method. Reimplemented from vtkWarpTransform.

void vtkGridTransform::InverseTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) | `[protected, virtual]`

| Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform) Reimplemented from vtkWarpTransform.

void vtkGridTransform::InverseTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) | `[protected, virtual]`

| Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform) Reimplemented from vtkWarpTransform.

## Member Data Documentation

void(* vtkGridTransform::InterpolationFunction)(float point[3], float displacement[3], float derivatives[3][3], void *gridPtr, int gridType, int inExt[6], int inInc[3])`[protected]`

int vtkGridTransform::InterpolationMode`[protected]`

| Definition at line 139 of file vtkGridTransform.h. Referenced by GetInterpolationModeAsString().

vtkImageData* vtkGridTransform::DisplacementGrid`[protected]`

| Definition at line 140 of file vtkGridTransform.h.

float vtkGridTransform::DisplacementScale`[protected]`

| Definition at line 141 of file vtkGridTransform.h.

float vtkGridTransform::DisplacementShift`[protected]`

| Definition at line 142 of file vtkGridTransform.h.

The documentation for this class was generated from the following file:

- Hybrid/vtkGridTransform.h